searchNodes=[{"doc":"Md is a markup parser allowing fully customized syntax definition and understanding the wide range of markdown out of the box. It is stream-aware, extendable, flexible, blazingly fast, with callbacks and more. Main Focus This library is not yet another markdown parser, rather it’s a highly configurable and extendable parser for any custom markdown-like markup. It has been created mostly to allow custom markdown syntax, like ^foo^ for superscript, or ⇓bar⇓ for subscript. It also supports custom parsers for anything that cannot be handled with generic parsers, inspired by markdown (something more complex than standard markdown provides.) The library provides callbacks for all the default syntax handlers, as well as for custom handlers, allowing the on-fly modification of what’s currently being processed. Md parses the incoming stream once and keeps the state, producing an AST of the input document. It has an ability to recover from errors collecting them. It currently does not support markdown tables (and I frankly doubt it ever will,) lists with embedded quotes, and other contrived syntax. If one needs to perfectly parse the common markdown, Md is probably not the correct choice. But if one wants to easily extend syntax almost without limits, Md might be good. Markup Handling There are several different syntax patterns recognizable by Md . Those are: custom — the custom parser implementing Md.Parser behavious would be called substitutes — simple substitution, like &quot;&lt;&quot; →  &quot;&amp;lt;&quot; escapes — characters to be treated as is, not as a part of syntax flush — somewhat breaking a paragraph flow, like triple-dash magnet — the markup for a single work following the patters, like #tag block — the whole block of input treated distinguished, like triple-backtick shift  — the same as block , but the opening marker should precede each line and &quot;\\n&quot; is treated as the closing marker pair — the opening marker followed by closing marker, and a subsequent pair of opening and closing, like ![name](#anchor) paragraph — a header, blockquote, or such, followed by a paragraph flow break list — a list, like - one\\n-two brace — a most common markdown feature, like text decoration or such (e. g. **bold** ) Syntax description The syntax must be configured at compile time (because parse/2 handlers are generated in compile time.) It is a map, having settings key settings : %{ outer : :p , span : :span , empty_tags : ~w|img hr br|a } and key ⇒ list_of_tuples key-values, providing a text markup representation and its handling rules. Here is the excerpt from the default parser for brace s brace : %{ &quot;*&quot; =&gt; %{ tag : :b } , &quot;_&quot; =&gt; %{ tag : :it } , &quot;**&quot; =&gt; %{ tag : :strong , attributes : %{ class : &quot;nota-bene&quot; } } , &quot;__&quot; =&gt; %{ tag : :em } , &quot;~&quot; =&gt; %{ tag : :s } , &quot;~~&quot; =&gt; %{ tag : :del } , &quot;`&quot; =&gt; %{ tag : :code , mode : :raw , attributes : %{ class : &quot;code-inline&quot; } } } For more examples of what properties are allowed for each kind of handlers, see the sources (ATM.)","ref":"Md.html","title":"Md","type":"module"},{"doc":"See Md.Parser.generate/1 .","ref":"Md.html#generate/1","title":"Md.generate/1","type":"function"},{"doc":"See Md.Parser.generate/2 .","ref":"Md.html#generate/2","title":"Md.generate/2","type":"function"},{"doc":"Interface to the library. Use parse/2 to parse the input to the state, use generate/{1,2} to produce an HTML out of the input. Examples iex&gt; Md . parse ( &quot; foo&quot; ) % Md.Parser.State { ast : [ { :p , nil , [ &quot;foo&quot; ] } ] , mode : [ :finished ] } iex&gt; Md . generate ( &quot;It’s all *bold* and _italic_!&quot; , format : :none ) &quot;&lt;p&gt;It’s all &lt;b&gt;bold&lt;/b&gt; and &lt;it&gt;italic&lt;/it&gt;!&lt;/p&gt;&quot;","ref":"Md.html#parse/2","title":"Md.parse/2","type":"function"},{"doc":"The listener behaviour to attach to the parser to receive callbacks when the elements are encountered and processed.","ref":"Md.Listener.html","title":"Md.Listener","type":"behaviour"},{"doc":"","ref":"Md.Listener.html#c:element/2","title":"Md.Listener.element/2","type":"callback"},{"doc":"","ref":"Md.Listener.html#t:attributes/0","title":"Md.Listener.attributes/0","type":"type"},{"doc":"","ref":"Md.Listener.html#t:branch/0","title":"Md.Listener.branch/0","type":"type"},{"doc":"","ref":"Md.Listener.html#t:context/0","title":"Md.Listener.context/0","type":"type"},{"doc":"","ref":"Md.Listener.html#t:element/0","title":"Md.Listener.element/0","type":"type"},{"doc":"","ref":"Md.Listener.html#t:leaf/0","title":"Md.Listener.leaf/0","type":"type"},{"doc":"","ref":"Md.Listener.html#t:parse_mode/0","title":"Md.Listener.parse_mode/0","type":"type"},{"doc":"","ref":"Md.Listener.html#t:state/0","title":"Md.Listener.state/0","type":"type"},{"doc":"","ref":"Md.Listener.html#t:trace/0","title":"Md.Listener.trace/0","type":"type"},{"doc":"Interface to implement for the custopm parsers. Custom parsers might be used in syntax declaration when the generic functionality is not enough. Let’s consider one needs a specific handling of links with titles. The generic engine does not support it, so one would need to implement a custom parser and instruct Md.Parser to use it with: # config/prod.exs config :md , syntax : %{ custom : %{ { &quot;![&quot; , MyApp.Parsers.Img } , ... } } Once the original parser would meet the &quot;![&quot; binary, it’d call MyApp.Parsers.Img.parse/2 . The latter must proceed until the tag is closed and return the remainder and the updated state as a tuple.","ref":"Md.Parser.html","title":"Md.Parser","type":"behaviour"},{"doc":"","ref":"Md.Parser.html#generate/2","title":"Md.Parser.generate/2","type":"function"},{"doc":"Takes a not parsed yet input and the state, returns the updated remainder and state.","ref":"Md.Parser.html#c:parse/2","title":"Md.Parser.parse/2","type":"callback"},{"doc":"The type to be used in all the intermediate states of parsing. The first element iof the tuple is the continuation (not parsed yet input,) and the latter is the current state.","ref":"Md.Parser.html#t:parsing_stage/0","title":"Md.Parser.parsing_stage/0","type":"type"},{"doc":"The internal state of the parser.","ref":"Md.Parser.State.html","title":"Md.Parser.State","type":"module"}]